#ifndef POWERUP_PPCLIB_PROTOS_H
#define POWERUP_PPCLIB_PROTOS_H

#ifdef __cplusplus
extern "C" {
#endif

extern void*	PPCLoadObject(char*);
extern void	PPCUnLoadObject(void*);
extern ULONG	PPCRunObject(void*,void*);
extern void*	PPCAllocMem(ULONG,ULONG);
extern void	PPCFreeMem(void*,ULONG);
extern void*	PPCAllocVec(ULONG,ULONG);
extern void*	PPCFreeVec(void*);

extern void	*PPCCreateTask(void*,
                               struct TagItem*);
extern void	*PPCCreateTaskTags(void*,
                                   unsigned long tag1Type, ... );
extern BOOL	PPCDeleteTask(void*);

extern void	PPCSignalTask(void*,ULONG);
extern void	*PPCFindTask(char	*);
extern ULONG	PPCRunKernelObject(void*,
                                   struct ModuleArgs*);
extern DOUBLE	PPCRunKernelObjectFPU(void*,
                                      struct ModuleArgs*);
extern ULONG	PPCGetTaskAttrs(void*,
                                struct TagItem*);
extern ULONG	PPCGetTaskAttrsTags(void*,
                                    unsigned long tag1Type,
                                    ...);
extern ULONG	PPCGetAttrs(struct TagItem*);
extern ULONG	PPCGetAttrsTags(unsigned long tag1Type,
                                ...);

extern void	*PPCFindTaskObject(void*);
extern ULONG	PPCReadLong(ULONG*);
extern void	PPCWriteLong(ULONG*,ULONG);
extern BOOL	PPCStartTask(void*,
                             struct TagItem*);
extern BOOL	PPCStartTaskTags(void*,
                                 unsigned long tag1Type, ... );
extern BOOL	PPCStopTask(void*,
                            struct TagItem*);
extern BOOL	PPCStopTaskTags(void*,
                                unsigned long tag1Type, ... );
extern ULONG	PPCSetTaskAttrs(void*,
                                struct TagItem*);
extern ULONG	PPCSetTaskAttrsTags(void*,
                                    unsigned long tag1Type,
                                    ...);
extern ULONG	PPCGetObjectAttrs(void*,
                                  struct PPCObjectInfo*,
                                  struct TagItem*);
extern ULONG	PPCGetObjectAttrsTags(void*,
                                      struct PPCObjectInfo*,
                                      unsigned long tag1Type,
                                      ... );

extern void	PPCWriteLongFlush(ULONG*,ULONG);
extern UWORD	PPCReadWord(UWORD*);
extern void	PPCWriteWord(UWORD*,UWORD);
extern UBYTE	PPCReadByte(UBYTE*);
extern void	PPCWriteByte(UBYTE*,UBYTE);
extern void*	PPCCreatePool(ULONG		MemFlags,
                              ULONG		PuddleSize,
                              ULONG		ThreshSize);
extern BOOL	PPCDeletePool(void*);
extern void*	PPCAllocPooled(void*,
                               ULONG);
extern void	PPCFreePooled(void*,
                              void*,
                              ULONG);
extern void	PPCFreeVecPooled(void*,
                                 void*);
extern void*	PPCAllocVecPooled(void*,
                                  ULONG);



extern void*	PPCCreatePort(struct TagItem*);
extern void*	PPCCreatePortTags(unsigned long tag1Type, ... );
extern BOOL	PPCDeletePort(void*);
extern void*	PPCObtainPort(struct TagItem*);
extern void*	PPCObtainPortTags(unsigned long tag1Type, ... );
extern BOOL	PPCReleasePort(void*);
extern void*	PPCCreateMessage(void*,
                                 ULONG);
extern void	PPCDeleteMessage(void*);
extern ULONG	PPCGetMessageAttr(void*,
                                  ULONG);
extern void*	PPCGetMessage(void*);
extern BOOL	PPCReplyMessage(void*);
extern BOOL	PPCSendMessage(void*,
                               void*,
                               void*,
                               ULONG,
                               ULONG);
extern void*	PPCWaitPort(void*);
extern void	PPCCacheClearE(void*,
                               ULONG,
                               ULONG);

extern void	PPCCacheInvalidE(void*,
                                 ULONG,
                                 ULONG);


extern void*	PPCCreatePortList(void**,ULONG);
extern void	PPCDeletePortList(void*);
extern BOOL	PPCAddPortList(void*,
                               void*);
extern void	PPCRemPortList(void*,
                               void*);
extern void*	PPCWaitPortList(void*);
extern ULONG	PPCGetPortListAttr(void*,
                                   ULONG);
extern void	PPCSetPortListAttr(void*,
                                   ULONG,
                                   ULONG);

extern void*	PPCLoadObjectTags(unsigned long tag1Type, ... );
extern void*	PPCLoadObjectTagList(struct TagItem*);


extern BOOL	PPCSetAttrs(struct TagItem*);
extern BOOL	PPCSetAttrsTags(unsigned long tag1Type, ... );

extern void	PPCCacheTrashE(void*,
                               ULONG,
                               ULONG);

#ifdef __cplusplus
}
#endif

#endif
